;
; ZOOM HER
;
.CONST
Zoom_Factor	EQU 4									;; must be greater than 1
Zoom_Speed	EQU 2									;; must be greater than 0


.DATA
ALIGN 16
Zoom_Source_X_x4		DWORD ?
Zoom_Width_x4			DWORD ?
Zoom_Source_Y			DWORD ?
Zoom_Height			DWORD ?

Zoom_Lines_TestValue	DWORD ?
Zoom_Lines_Counter		DWORD ?
Zoom_Step				DWORD 0
Zoom_Step_Max			DWORD ?

Zoom_X_Ratio			DWORD ?
Zoom_Y_Ratio			DWORD ?
Zoom_Flag_Direction		DWORD 0


.CODE
cmp MP_Init_Effect_05,1
jne MP_Apply_Effect_05
;
; init here
;
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


;
; bmp used ?
;
		mov eax,0										;; ) define the victim (the number of the bmp used -1)
		call UpdateCurrentVictim							;; )


;
; init the zoom
;
		mov Zoom_Step,0
		mov Zoom_Flag_Direction,0
		mov ecx,Zoom_Factor
; for width
		mov ebx,Backup_Screen.Screen_Width
		mov eax,ebx
		cdq											;; ) width div zoom factor
		div ecx										;; )
		sub ebx,eax
		shr ebx,1										;; remain div 2
		mov Zoom_Step_Max,ebx							;; max X
; for height
		mov ebx,Backup_Screen.Screen_Height
		mov eax,ebx
		cdq											;; ) height div zoom factor
		div ecx										;; )
		sub ebx,eax
		shr ebx,1										;; remain div 2
		cmp ebx,Zoom_Step_Max							;; cmp max Y to max X
		ja Zoom_KeepStepMax								;; ) keep the smallest
		mov Zoom_Step_Max,ebx							;; )
Zoom_KeepStepMax:
; obtain screen ratios (<< 16, to avoid divisions during the main loop)
		mov esi,000010000h								;; the default ratio value for the greatest width/height
		mov ecx,Backup_Screen.Screen_Height
		mov ebx,Backup_Screen.Screen_Width
		cmp ebx,ecx
		jl Zoom_RatioYGreater
Zoom_RatioXGreater:
		mov eax,esi
		mul ebx
		cdq
		div ecx
		mov Zoom_X_Ratio,esi
		mov Zoom_Y_Ratio,eax
		jmp Zoom_EndRatios
Zoom_RatioYGreater:
		mov eax,esi
		mul ecx
		cdq
		div ebx
		mov Zoom_X_Ratio,eax
		mov Zoom_Y_Ratio,esi
;		jmp Zoom_EndRatios
Zoom_EndRatios:


;
; simply copy the backup of the screen (it serve as transission image)
;
		mov eax,Work_Screen.Screen_Size
		mov esi,Backup_Screen.Pointer
		mov edi,Work_Screen.Pointer
		call CopyMemArea_Mmx


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
mov MP_Init_Effect_05,0
jmp MP_End_Effect_05
MP_Apply_Effect_05:
;
; effect here
;
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


		push ebp										;; because ebp usage


;
; update data, depending of the step of the zoom
;

; for height
		mov eax,Zoom_Step
		mov edx,Zoom_X_Ratio
		mul edx
		shr eax,16									;; coz only the higher word is essential (you remember 000010000h ?)
		mov edx,Backup_Screen.Screen_Height
		mov Zoom_Source_Y,eax
		add eax,eax									;; mul 2
		sub edx,eax
		mov Zoom_Height,edx
; for width
		mov eax,Zoom_Step
		mov edx,Zoom_Y_Ratio
		mul edx
		shr eax,16									;; coz only the higher word is essential
		mov edx,Backup_Screen.Screen_Width_x4
		shl eax,2										;; mul 4 (for corresponding dwords)
		mov Zoom_Source_X_x4,eax
		add eax,eax									;; mul 2
		sub edx,eax
		mov Zoom_Width_x4,edx


; calc the source position
		mov esi,Backup_Screen.Pointer
		mov edx,Backup_Screen.Screen_Width_x4
		mov eax,Zoom_Source_Y
		mul edx
		add eax,Zoom_Source_X_x4
		add esi,eax
; init others registers
		mov eax,Backup_Screen.Screen_Height
		mov ecx,Backup_Screen.Screen_Width_x4
		mov ebx,Work_Screen.Screen_Height
		mov edx,Work_Screen.Screen_Width_x4
		mov edi,Work_Screen.Pointer
		mov ebp,ebx
		neg ebp
		mov Zoom_Lines_Counter,ebx
		mov Zoom_Lines_TestValue,ebp
; loop for height
Zoom_HeightLoop:
		push esi										;; keep the beginning location

		mov ebx,edx
		add edi,edx
		neg ebx
		mov eax,DWORD PTR [esi]
		mov ebp,ebx
; loop for width
Zoom_WidthLoop:
		add ebx,Zoom_Width_x4
		js Zoom_AvoidReinitWidthTestValue
		sub ebx,edx
		mov eax,DWORD PTR [esi]
		add esi,DWORD
Zoom_AvoidReinitWidthTestValue:
		mov DWORD PTR [edi+ebp],eax
; end of width loop
		add ebp,DWORD
		jnz Zoom_WidthLoop

		pop esi										;; restore location

		mov eax,Zoom_Height
		add Zoom_Lines_TestValue,eax
		js Zoom_AvoidReinitHeightTestValue
		mov ebx,Work_Screen.Screen_Height
		add esi,ecx
		sub Zoom_Lines_TestValue,ebx
; end of height loop
Zoom_AvoidReinitHeightTestValue:
		dec Zoom_Lines_Counter
		jnz Zoom_HeightLoop


;
; update zoom step (for the next use)
;
		mov eax,Zoom_Step
		cmp Zoom_Flag_Direction,1
		je Zoom_DecStep
Zoom_IncStep:
		add eax,Zoom_Speed
		cmp eax,Zoom_Step_Max
		jl Zoom_EndStep
		mov eax,Zoom_Step_Max
		mov Zoom_Flag_Direction,1
		jmp Zoom_EndStep
Zoom_DecStep:
		sub eax,Zoom_Speed
		cmp eax,0
		jg Zoom_EndStep
		mov eax,0
		mov Zoom_Flag_Direction,0
;		jmp Zoom_EndStep
Zoom_EndStep:
		mov Zoom_Step,eax


		pop ebp										;; restore ebp


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; end of the effect here
;
MP_End_Effect_05:
